#ifndef BUILDING_WIDGET_HPP_INCLUDED
#define BUILDING_WIDGET_HPP_INCLUDED

#include <boost/function.hpp>

#include "building.hpp"
#include "player.hpp"
#include "texture.hpp"
#include "widget.hpp"

class building_widget : public gui::widget
{
public:
	building_widget(player_ptr p, const_building_ptr b, boost::function<void()> on_click);
private:
	void handle_draw() const;
	bool handle_event(const SDL_Event& event, bool claimed);

	player_ptr player_;
	const_building_ptr building_;
	boost::function<void()> on_click_;
	std::vector<graphics::texture> title_, title_gray_;
	graphics::texture culture_, victory_points_;
};

#endif
