
/*
   Copyright (C) 2007 by David White <dave.net>
   Part of the Silver Tree Project

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 or later.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/
#ifndef BUTTON_HPP_INCLUDED
#define BUTTON_HPP_INCLUDED

#include <boost/function.hpp>
#include <boost/scoped_ptr.hpp>

#include "texture.hpp"
#include "widget.hpp"
#include "framed_gui_element.hpp"


namespace gui {

class button : public widget
{
public:
	button(widget_ptr label, boost::function<void ()> onclick);

	void set_enabled(bool enabled) { enabled_ = enabled; }
	void set_enabled_calculator(boost::function<bool ()> fn);

private:
	bool enabled() const;

	bool in_button(int x, int y) const;
	void handle_draw() const;
	bool handle_event(const SDL_Event& event, bool claimed);

	widget_ptr label_;
	boost::function<void ()> onclick_;
	
	const_framed_gui_element_ptr normal_button_image_set_,depressed_button_image_set_,focus_button_image_set_,current_button_image_set_;

	bool enabled_;
	boost::scoped_ptr<boost::function<bool ()> > enabledfn_;
};

typedef boost::shared_ptr<button> button_ptr;

}

#endif
