#ifndef DEITY_HPP_INCLUDED
#define DEITY_HPP_INCLUDED

#include <boost/shared_ptr.hpp>

#include <vector>

class deity;

typedef boost::shared_ptr<deity> deity_ptr;
typedef boost::shared_ptr<const deity> const_deity_ptr;

class player;

class deity
{
public:
	static int num_deities();
	static deity_ptr get(int id);
	static deity_ptr get_by_name(const std::string& name);
	static void set_active(int ndeity);
	static void add_active(int ndeity);
	static void clear_active();
	static const std::vector<int>& active();

	deity(const char* name, const char* help);
	virtual ~deity();
	void set_number(int num) { number_ = num; }
	int number() const { return number_; }
	const std::vector<int>& priests() const { return priests_; }
	void add_priest(int n);
	void clear_priests() { priests_.clear(); }

	const char* name() const { return name_; }
	const char* help() const { return help_; }

	virtual void apply_effects(player& p, int power) = 0;

	virtual int unleash_plague();
	virtual int plague_unleashed() const { return 0; }
	virtual void clear_plague() {}

	virtual int ai_rating(const player& p, int power) const = 0;


private:
	int number_;
	const char* name_;
	const char* help_;
	std::vector<int> priests_;
};

#endif
