#include "game.hpp"

game::game()
{
	for(int n = 0; n != 4; ++n) {
		players_.push_back(player_ptr(new player(*this, n == 0 ? PLAYER_LOCAL_HUMAN : PLAYER_LOCAL_AI, n)));
	}
}

game::game(int nslot, int nhumans)
{
	for(int n = 0; n != 4; ++n) {
		PLAYER_TYPE type = PLAYER_LOCAL_AI;
		if(n == nslot) {
			type = PLAYER_LOCAL_HUMAN;
		} else if(n < nhumans) {
			type = PLAYER_NETWORK_HUMAN;
		}

		players_.push_back(player_ptr(new player(*this, type, n)));
	}
}

int game::local_player() const
{
	for(int n = 0; n != players_.size(); ++n) {
		if(players_[n]->is_local_human() && !players_[n]->is_network()) {
			return n;
		}
	}

	return 0;
}
