#include "font.hpp"
#include "priests_widget.hpp"
#include "raster.hpp"

priests_widget::priests_widget(const game& g, player_ptr p) : game_(g), player_(p), title_(font::render_text("Priests", graphics::color_yellow(), 18))
{
	set_dim(160, 156);
}

int priests_widget::priest_x(int nplayer, int num) const
{
	return x() + 32*num + 16;
}

int priests_widget::priest_y(int nplayer, int num) const
{
	return y() + 22 + 16 + 32*nplayer;
}

void priests_widget::handle_draw() const
{
	graphics::blit_texture(title_, x(), y());
	const SDL_Rect rect = {x(), y()+22, width(), 128};
	graphics::draw_hollow_rect(rect, graphics::color_white());
	for(int m = 0; m != game_.players().size(); ++m) {
		player_ptr p = game_.players()[m];
		for(int n = 0; n != p->max_priests(); ++n) {
			graphics::draw_circle(x() + 32*n + 16, rect.y + 16 + 32*m, 12, graphics::color_white());
			graphics::draw_circle(x() + 32*n + 16, rect.y + 16 + 32*m, 11, n < p->num_priests() ? player::get_color(p->number()) : graphics::color_black());
		}
	}
}
