#include "font.hpp"
#include "raster.hpp"
#include "resources_widget.hpp"

resources_widget::resources_widget(player_ptr p)
  : player_(p),
    resource_title_(font::render_text("Resources", graphics::color_yellow(), 18)),
    tribute_title_(font::render_text("Tribute", graphics::color_yellow(), 18))
{
	set_dim(160, 160);
}

void resources_widget::handle_draw() const
{
	graphics::blit_texture(resource_title_, x(), y());
	const SDL_Rect resources_rect = {x(), y()+22,width(),64};
	graphics::draw_hollow_rect(resources_rect, graphics::color_white());
	graphics::blit_texture(tribute_title_, x(), y()+90);
	const SDL_Rect tribute_rect = {x(), y()+112,width(),32};
	graphics::draw_hollow_rect(tribute_rect, graphics::color_white());

	int xpos = 0, ypos = 0;
	for(int resource = 0; resource != NUM_RESOURCES; ++resource) {
		RESOURCE_TYPE type = static_cast<RESOURCE_TYPE>(resource);
		for(int n = 0; n != player_->resources(type); ++n) {
			graphics::blit_texture(player::development_icon(static_cast<DEVELOPMENT_TYPE>(type)), resources_rect.x + xpos, resources_rect.y + ypos);
			xpos += 32;
			if(xpos >= width()) {
				xpos = 0;
				ypos += 32;
			}
		}
	}

	xpos = 0;
	for(int resource = 0; resource != NUM_RESOURCES; ++resource) {
		RESOURCE_TYPE type = static_cast<RESOURCE_TYPE>(resource);
		for(int n = 0; n != player_->tribute(type); ++n) {
			graphics::blit_texture(player::development_icon(static_cast<DEVELOPMENT_TYPE>(type)), tribute_rect.x + xpos, tribute_rect.y + ypos);
			xpos += 32;
		}
	}
}
